Code

Merge branch 'maint'
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
6 USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example:       git-rebase master~1 topic
25         A---B---C topic                   A'\''--B'\''--C'\'' topic
26        /                   -->           /
27   D---E---F---G master          D---E---F---G master
28 '
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
37 RESOLVEMSG="
38 When you have resolved this problem run \"git rebase --continue\".
39 If you would prefer to skip this patch, instead run \"git rebase --skip\".
40 To restore the original branch and stop rebasing run \"git rebase --abort\".
41 "
42 unset newbase
43 strategy=recursive
44 do_merge=
45 dotest=$GIT_DIR/.dotest-merge
46 prec=4
47 verbose=
48 git_am_opt=
50 continue_merge () {
51         test -n "$prev_head" || die "prev_head must be defined"
52         test -d "$dotest" || die "$dotest directory does not exist"
54         unmerged=$(git ls-files -u)
55         if test -n "$unmerged"
56         then
57                 echo "You still have unmerged paths in your index"
58                 echo "did you forget to use git add?"
59                 die "$RESOLVEMSG"
60         fi
62         cmt=`cat "$dotest/current"`
63         if ! git diff-index --quiet HEAD --
64         then
65                 if ! git commit --no-verify -C "$cmt"
66                 then
67                         echo "Commit failed, please do not call \"git commit\""
68                         echo "directly, but instead do one of the following: "
69                         die "$RESOLVEMSG"
70                 fi
71                 printf "Committed: %0${prec}d " $msgnum
72         else
73                 printf "Already applied: %0${prec}d " $msgnum
74         fi
75         git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
77         prev_head=`git rev-parse HEAD^0`
78         # save the resulting commit so we can read-tree on it later
79         echo "$prev_head" > "$dotest/prev_head"
81         # onto the next patch:
82         msgnum=$(($msgnum + 1))
83         echo "$msgnum" >"$dotest/msgnum"
84 }
86 call_merge () {
87         cmt="$(cat "$dotest/cmt.$1")"
88         echo "$cmt" > "$dotest/current"
89         hd=$(git rev-parse --verify HEAD)
90         cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
91         msgnum=$(cat "$dotest/msgnum")
92         end=$(cat "$dotest/end")
93         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
94         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
95         export GITHEAD_$cmt GITHEAD_$hd
96         git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
97         rv=$?
98         case "$rv" in
99         0)
100                 unset GITHEAD_$cmt GITHEAD_$hd
101                 return
102                 ;;
103         1)
104                 git rerere
105                 die "$RESOLVEMSG"
106                 ;;
107         2)
108                 echo "Strategy: $rv $strategy failed, try another" 1>&2
109                 die "$RESOLVEMSG"
110                 ;;
111         *)
112                 die "Unknown exit code ($rv) from command:" \
113                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
114                 ;;
115         esac
118 move_to_original_branch () {
119         test -z "$head_name" &&
120                 head_name="$(cat "$dotest"/head-name)" &&
121                 onto="$(cat "$dotest"/onto)" &&
122                 orig_head="$(cat "$dotest"/orig-head)"
123         case "$head_name" in
124         refs/*)
125                 message="rebase finished: $head_name onto $onto"
126                 git update-ref -m "$message" \
127                         $head_name $(git rev-parse HEAD) $orig_head &&
128                 git symbolic-ref HEAD $head_name ||
129                 die "Could not move back to $head_name"
130                 ;;
131         esac
134 finish_rb_merge () {
135         move_to_original_branch
136         rm -r "$dotest"
137         echo "All done."
140 is_interactive () {
141         test -f "$dotest"/interactive ||
142         while :; do case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
143                 shift
144         done && test -n "$1"
147 is_interactive "$@" && exec git-rebase--interactive "$@"
149 while test $# != 0
150 do
151         case "$1" in
152         --continue)
153                 git diff-files --quiet || {
154                         echo "You must edit all merge conflicts and then"
155                         echo "mark them as resolved using git add"
156                         exit 1
157                 }
158                 if test -d "$dotest"
159                 then
160                         prev_head=$(cat "$dotest/prev_head")
161                         end=$(cat "$dotest/end")
162                         msgnum=$(cat "$dotest/msgnum")
163                         onto=$(cat "$dotest/onto")
164                         continue_merge
165                         while test "$msgnum" -le "$end"
166                         do
167                                 call_merge "$msgnum"
168                                 continue_merge
169                         done
170                         finish_rb_merge
171                         exit
172                 fi
173                 head_name=$(cat .dotest/head-name) &&
174                 onto=$(cat .dotest/onto) &&
175                 orig_head=$(cat .dotest/orig-head) &&
176                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
177                 move_to_original_branch
178                 exit
179                 ;;
180         --skip)
181                 git reset --hard HEAD || exit $?
182                 if test -d "$dotest"
183                 then
184                         git rerere clear
185                         prev_head=$(cat "$dotest/prev_head")
186                         end=$(cat "$dotest/end")
187                         msgnum=$(cat "$dotest/msgnum")
188                         msgnum=$(($msgnum + 1))
189                         onto=$(cat "$dotest/onto")
190                         while test "$msgnum" -le "$end"
191                         do
192                                 call_merge "$msgnum"
193                                 continue_merge
194                         done
195                         finish_rb_merge
196                         exit
197                 fi
198                 head_name=$(cat .dotest/head-name) &&
199                 onto=$(cat .dotest/onto) &&
200                 orig_head=$(cat .dotest/orig-head) &&
201                 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
202                 move_to_original_branch
203                 exit
204                 ;;
205         --abort)
206                 git rerere clear
207                 if test -d "$dotest"
208                 then
209                         move_to_original_branch
210                 elif test -d .dotest
211                 then
212                         dotest=.dotest
213                         move_to_original_branch
214                 else
215                         die "No rebase in progress?"
216                 fi
217                 git reset --hard $(cat $dotest/orig-head)
218                 rm -r "$dotest"
219                 exit
220                 ;;
221         --onto)
222                 test 2 -le "$#" || usage
223                 newbase="$2"
224                 shift
225                 ;;
226         -M|-m|--m|--me|--mer|--merg|--merge)
227                 do_merge=t
228                 ;;
229         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
230                 --strateg=*|--strategy=*|\
231         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
232                 case "$#,$1" in
233                 *,*=*)
234                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
235                 1,*)
236                         usage ;;
237                 *)
238                         strategy="$2"
239                         shift ;;
240                 esac
241                 do_merge=t
242                 ;;
243         -v|--verbose)
244                 verbose=t
245                 ;;
246         --whitespace=*)
247                 git_am_opt="$git_am_opt $1"
248                 ;;
249         -C*)
250                 git_am_opt="$git_am_opt $1"
251                 ;;
252         -*)
253                 usage
254                 ;;
255         *)
256                 break
257                 ;;
258         esac
259         shift
260 done
262 # Make sure we do not have .dotest
263 if test -z "$do_merge"
264 then
265         if mkdir .dotest
266         then
267                 rmdir .dotest
268         else
269                 echo >&2 '
270 It seems that I cannot create a .dotest directory, and I wonder if you
271 are in the middle of patch application or another rebase.  If that is not
272 the case, please rm -fr .dotest and run me again.  I am stopping in case
273 you still have something valuable there.'
274                 exit 1
275         fi
276 else
277         if test -d "$dotest"
278         then
279                 die "previous dotest directory $dotest still exists." \
280                         'try git-rebase < --continue | --abort >'
281         fi
282 fi
284 # The tree must be really really clean.
285 git update-index --refresh || exit
286 diff=$(git diff-index --cached --name-status -r HEAD --)
287 case "$diff" in
288 ?*)     echo "cannot rebase: your index is not up-to-date"
289         echo "$diff"
290         exit 1
291         ;;
292 esac
294 # The upstream head must be given.  Make sure it is valid.
295 upstream_name="$1"
296 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
297     die "invalid upstream $upstream_name"
299 # Make sure the branch to rebase onto is valid.
300 onto_name=${newbase-"$upstream_name"}
301 onto=$(git rev-parse --verify "${onto_name}^0") || exit
303 # If a hook exists, give it a chance to interrupt
304 if test -x "$GIT_DIR/hooks/pre-rebase"
305 then
306         "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
307                 echo >&2 "The pre-rebase hook refused to rebase."
308                 exit 1
309         }
310 fi
312 # If the branch to rebase is given, first switch to it.
313 case "$#" in
314 2)
315         branch_name="$2"
316         git-checkout "$2" || usage
317         ;;
318 *)
319         if branch_name=`git symbolic-ref -q HEAD`
320         then
321                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
322         else
323                 branch_name=HEAD ;# detached
324         fi
325         ;;
326 esac
327 branch=$(git rev-parse --verify "${branch_name}^0") || exit
329 # Now we are rebasing commits $upstream..$branch on top of $onto
331 # Check if we are already based on $onto with linear history,
332 # but this should be done only when upstream and onto are the same.
333 mb=$(git merge-base "$onto" "$branch")
334 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
335         # linear history?
336         ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
337 then
338         echo >&2 "Current branch $branch_name is up to date."
339         exit 0
340 fi
342 if test -n "$verbose"
343 then
344         echo "Changes from $mb to $onto:"
345         # We want color (if set), but no pager
346         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
347 fi
349 # move to a detached HEAD
350 orig_head=$(git rev-parse HEAD^0)
351 head_name=$(git symbolic-ref HEAD 2> /dev/null)
352 case "$head_name" in
353 '')
354         head_name="detached HEAD"
355         ;;
356 *)
357         git checkout "$orig_head" > /dev/null 2>&1 ||
358                 die "could not detach HEAD"
359         ;;
360 esac
362 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
363 echo "First, rewinding head to replay your work on top of it..."
364 git-reset --hard "$onto"
366 # If the $onto is a proper descendant of the tip of the branch, then
367 # we just fast forwarded.
368 if test "$mb" = "$branch"
369 then
370         echo >&2 "Fast-forwarded $branch_name to $onto_name."
371         move_to_original_branch
372         exit 0
373 fi
375 if test -z "$do_merge"
376 then
377         git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
378         git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
379         move_to_original_branch
380         ret=$?
381         test 0 != $ret -a -d .dotest &&
382                 echo $head_name > .dotest/head-name &&
383                 echo $onto > .dotest/onto &&
384                 echo $orig_head > .dotest/orig-head
385         exit $ret
386 fi
388 # start doing a rebase with git-merge
389 # this is rename-aware if the recursive (default) strategy is used
391 mkdir -p "$dotest"
392 echo "$onto" > "$dotest/onto"
393 echo "$onto_name" > "$dotest/onto_name"
394 prev_head=$orig_head
395 echo "$prev_head" > "$dotest/prev_head"
396 echo "$orig_head" > "$dotest/orig-head"
397 echo "$head_name" > "$dotest/head-name"
399 msgnum=0
400 for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
401 do
402         msgnum=$(($msgnum + 1))
403         echo "$cmt" > "$dotest/cmt.$msgnum"
404 done
406 echo 1 >"$dotest/msgnum"
407 echo $msgnum >"$dotest/end"
409 end=$msgnum
410 msgnum=1
412 while test "$msgnum" -le "$end"
413 do
414         call_merge "$msgnum"
415         continue_merge
416 done
418 finish_rb_merge